diff --git a/src/AmtPtpDeviceSpiKm/Device.c b/src/AmtPtpDeviceSpiKm/Device.c
index a7b76b2..3cf4020 100644
--- a/src/AmtPtpDeviceSpiKm/Device.c
+++ b/src/AmtPtpDeviceSpiKm/Device.c
@@ -312,7 +312,10 @@ AmtPtpEvtDeviceD0Entry(
 
 	pDeviceContext = DeviceGetContext(Device);
 
-	// Enable SPI trackpad; this might fail but can be retried later
+	// Attempt to enable SPI trackpad
+	// this might fail but can be retried later
+	// The state retains unless the power rail of trackpad
+	// has been cut
 	Status = AmtPtpSpiSetState(
 		Device,
 		TRUE
@@ -336,14 +339,6 @@ AmtPtpEvtDeviceD0Entry(
 		pDeviceContext->DeviceStatus = D0ActiveAndConfigured;
 	}
 
-	// Reset mapping
-	for (UINT8 i = 0; i < MAPPING_MAX; i++)
-	{
-		pDeviceContext->PtpMapping[i].ContactID = -1;
-		pDeviceContext->PtpMapping[i].OriginalX = -1;
-		pDeviceContext->PtpMapping[i].OriginalY = -1;
-	}
-
 	// Set time
 	KeQueryPerformanceCounter(
 		&pDeviceContext->LastReportTime
@@ -393,14 +388,6 @@ AmtPtpEvtDeviceD0Exit(
 	// When the queue is empty, this is expected
 	Status = STATUS_SUCCESS;
 
-	// Reset mapping
-	for (UINT8 i = 0; i < MAPPING_MAX; i++)
-	{
-		pDeviceContext->PtpMapping[i].ContactID = -1;
-		pDeviceContext->PtpMapping[i].OriginalX = -1;
-		pDeviceContext->PtpMapping[i].OriginalY = -1;
-	}
-
 	TraceEvents(
 		TRACE_LEVEL_INFORMATION,
 		TRACE_DRIVER,
diff --git a/src/AmtPtpDeviceSpiKm/Device.h b/src/AmtPtpDeviceSpiKm/Device.h
index 36d8c85..f078335 100644
--- a/src/AmtPtpDeviceSpiKm/Device.h
+++ b/src/AmtPtpDeviceSpiKm/Device.h
@@ -73,8 +73,6 @@ typedef struct _DEVICE_CONTEXT
 	BOOLEAN PtpInputOn;
 	BOOLEAN PtpReportTouch;
 	BOOLEAN PtpReportButton;
-	// Should be PTP_MAX_CONTACT * 2
-	PTP_AAPL_MAPPING PtpMapping[MAPPING_MAX];
 
 	// Timer
 	LARGE_INTEGER LastReportTime;
diff --git a/src/AmtPtpDeviceSpiKm/Input.c b/src/AmtPtpDeviceSpiKm/Input.c
index 5b66ed8..090432e 100644
--- a/src/AmtPtpDeviceSpiKm/Input.c
+++ b/src/AmtPtpDeviceSpiKm/Input.c
@@ -24,7 +24,7 @@ AmtPtpSpiInputRoutineWorker(
 			"%!FUNC! Unexpected call while device is in D3 status"
 		);
 
-		WdfRequestComplete(PtpRequest, STATUS_DEVICE_NOT_READY);
+		WdfRequestComplete(PtpRequest, STATUS_UNSUCCESSFUL);
 		return;
 	}
 
@@ -45,33 +45,6 @@ AmtPtpSpiInputRoutineWorker(
 		return;
 	}
 
-	// Late-init for the sleep workaround
-	if (pDeviceContext->DeviceStatus == D0ActiveAndUnconfigured) {
-		TraceEvents(
-			TRACE_LEVEL_INFORMATION,
-			TRACE_DRIVER,
-			"%!FUNC! Re-initialize device for sleep workaround"
-		);
-
-		Status = AmtPtpSpiSetState(
-			Device,
-			TRUE
-		);
-
-		if (!NT_SUCCESS(Status))
-		{
-			TraceEvents(
-				TRACE_LEVEL_ERROR,
-				TRACE_DRIVER,
-				"%!FUNC! AmtPtpSpiSetState failed with %!STATUS!. Ignored anyway.",
-				Status
-			);
-		}
-		else {
-			pDeviceContext->DeviceStatus = D0ActiveAndConfigured;
-		}
-	}
-
 	WDF_OBJECT_ATTRIBUTES_INIT_CONTEXT_TYPE(&Attributes, WORKER_REQUEST_CONTEXT);
 	Attributes.ParentObject = Device;
 
@@ -136,8 +109,14 @@ AmtPtpSpiInputRoutineWorker(
 			Status
 		);
 
-		WdfObjectDelete(SpiHidReadOutputMemory);
-		WdfObjectDelete(SpiHidReadRequest);
+		if (SpiHidReadOutputMemory != NULL) {
+			WdfObjectDelete(SpiHidReadOutputMemory);
+		}
+
+		if (SpiHidReadRequest != NULL) {
+			WdfObjectDelete(SpiHidReadRequest);
+		}
+		
 		return;
 	}
 
@@ -161,8 +140,13 @@ AmtPtpSpiInputRoutineWorker(
 			"%!FUNC! AmtPtpSpiInputRoutineWorker request failed to sent"
 		);
 
-		WdfObjectDelete(SpiHidReadOutputMemory);
-		WdfObjectDelete(SpiHidReadRequest);
+		if (SpiHidReadOutputMemory != NULL) {
+			WdfObjectDelete(SpiHidReadOutputMemory);
+		}
+
+		if (SpiHidReadRequest != NULL) {
+			WdfObjectDelete(SpiHidReadRequest);
+		}
 	}
 }
 
@@ -187,7 +171,6 @@ AmtPtpRequestCompletionRoutine(
 
 	LARGE_INTEGER CurrentCounter;
 	LONGLONG CounterDelta;
-	BOOLEAN SessionEnded = TRUE;
 
 	UNREFERENCED_PARAMETER(Target);
 
@@ -212,14 +195,38 @@ AmtPtpRequestCompletionRoutine(
 	SpiRequestLength = (LONG) WdfRequestGetInformation(SpiRequest);
 	pSpiTrackpadPacket = (PSPI_TRACKPAD_PACKET) WdfMemoryGetBuffer(Params->Parameters.Ioctl.Output.Buffer, NULL);
 
-	// Safe measurement for buffer overrun
+	// Safe measurement for buffer overrun and device state reset
 	if (SpiRequestLength < 46) {
 		TraceEvents(
 			TRACE_LEVEL_ERROR,
 			TRACE_DRIVER,
-			"%!FUNC! Input too small: %d < 46",
+			"%!FUNC! Input too small: %d < 46. Attempt to re-enable the device.",
 			SpiRequestLength
 		);
+
+		if (pDeviceContext->DeviceStatus == D0ActiveAndUnconfigured) {
+			Status = AmtPtpSpiSetState(
+				pDeviceContext->SpiDevice,
+				TRUE
+			);
+
+			if (!NT_SUCCESS(Status))
+			{
+				TraceEvents(
+					TRACE_LEVEL_ERROR,
+					TRACE_DRIVER,
+					"%!FUNC! AmtPtpSpiSetState failed with %!STATUS!.",
+					Status
+				);
+			}
+			else {
+				pDeviceContext->DeviceStatus = D0ActiveAndConfigured;
+				AmtPtpSpiInputRoutineWorker(pDeviceContext->SpiDevice, PtpRequest);
+				// Bypass PTP request completion
+				goto cleanup;
+			}
+		}
+
 		Status = STATUS_DEVICE_DATA_ERROR;
 		goto exit;
 	}
@@ -254,8 +261,6 @@ AmtPtpRequestCompletionRoutine(
 		PtpReport.Contacts[Count].Confidence = (pSpiTrackpadPacket->Fingers[Count].TouchMajor < 2500 &&
 			pSpiTrackpadPacket->Fingers[Count].TouchMinor < 2500) ? 1 : 0;
 
-		if (!SessionEnded && PtpReport.Contacts[Count].TipSwitch) SessionEnded = FALSE;
-
 		TraceEvents(
 			TRACE_LEVEL_INFORMATION,
 			TRACE_HID_INPUT,
@@ -268,16 +273,6 @@ AmtPtpRequestCompletionRoutine(
 		);
 	}
 
-	if (SessionEnded)
-	{
-		for (UINT8 i = 0; i < MAPPING_MAX; i++)
-		{
-			pDeviceContext->PtpMapping[i].ContactID = -1;
-			pDeviceContext->PtpMapping[i].OriginalX = -1;
-			pDeviceContext->PtpMapping[i].OriginalY = -1;
-		}
-	}
-
 	if (CounterDelta >= 0xFF)
 	{
 		PtpReport.ScanTime = 0xFF;
@@ -339,5 +334,7 @@ AmtPtpRequestCompletionRoutine(
 	// Clean up
 	pSpiTrackpadPacket = NULL;
 	WdfObjectDelete(SpiRequest);
-	WdfObjectDelete(RequestContext->RequestMemory);
+	if (RequestContext->RequestMemory != NULL) {
+		WdfObjectDelete(RequestContext->RequestMemory);
+	}
 }
